%define dist .el6

# Set the following to 0 if you want to build as 32bit
%define _want_64bit 1

# Only if you're developing, for normal builds keep this off
%define with_git 0

Summary: The SILO boot loader for SPARCs
Name: silo
Version: 1.4.14
Release: 4.0.18%{?dist}
License: GPLv2+
#ExclusiveArch: sparcv9 sparc
Group: System Environment/Base

# this is evil
# I'm doing this to get around a horrible foobar in 32/64 bit
# Should I get around to making this build in a 64bit environment this will vanish
BuildRequires: glibc-static
%if %{with_git}
BuildRequires: git
%endif
%global _binaries_in_noarch_packages_terminate_build 0
%define debug_package %{nil}

URL:    http://www.sparc-boot.org
# Source: http://www.sparc-boot.org/pub/silo/silo-%{version}.tar.bz2
# git clone git://git.kernel.org/pub/scm/linux/kernel/git/davem/silo.git
# tar -cjvf silo.tar.bz2 silo
# Source0: silo.tar.bz2

# Remastered with full version
Source0: silo-1.4.14.tar.gz
Patch0:  silo-1.4.14-preventoverlap.patch
Patch1:  silo-1.4.14-__sprintf_chk.patch
Patch2:  silo-1.4.14-sparc64.patch
Patch3:  silo-1.4.14-cmdline-length-inc.patch
Patch4:  silo-1.4.14-tilo-wipedout-compile-flags.patch
Patch5:  silo-1.4.14-align-4MB-boundary.patch
Patch6:	 silo-1.4.14-iso-before-ext2.patch
Patch7:  silo-1.4.14-build-as-64bit.patch
Patch8:  silo-1.4.14-tilo-big-buffer.patch
Patch9:  silo-1.4.14-tilo-sun4v.patch
Patch10: silo-1.4.14-add-release.patch
Patch11: silo-1.4.14-DEBUGGING.patch
Patch12: silo-1.4.14-release-update.patch
Patch13: silo-1.4.14-timer-timeout.patch
Patch14: silo-1.4.14-prevent-merging-of-labels.patch
Patch15: 0015-GPT-tweak.patch

BuildRequires: elftoaout e2fsprogs-devel

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%description
The silo package installs the SILO (Sparc Improved LOader) boot
loader, which you'll need to boot the Linux kernel on a SPARC.  SILO
installs onto your system's boot block and can be configured to boot
Linux, Solaris and SunOS.

%prep 
%setup -q 
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%if 0%{?_want_64bit:1}
%patch7 -p1
%endif
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1

%if %{with_git}
git init
git config user.email "clueless@somewhere.com"
git config user.name "Dazed and confused"
git add .
git commit -a -q -m "%{version} baseline."
git tag %{name}-%{version}-%{release}
%endif


%build
# if RELEASE isn't set a datestamp will be used
# if DEBUG isn't set, Rules.make will set DEBUGGING to 0
make %{?_smp_mflags} SILO_RELEASE=%{release} # DEBUG=1

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
rm -rf $RPM_BUILD_ROOT/etc/silo.conf 

%clean
rm -rf $RPM_BUILD_ROOT

%post
# because the /boot/*.b files have probably shifted around
# we need to rebuild the bootloader as it needs to update
# where the sectors are for booting the necessary .b files
# During install silo is copied over but the config file has not yet
# been written (but aaconda later does this ad runs silo -f properly
# So we'll look for the conf file in it's default location and if it
# is there and not a 0 length file we'll assume it's been written out
# properly and run silo -f ourselves ( use [ -s ] )
CFG=/boot/silo.conf
if [ -s $CFG ]; then 
  /sbin/silo -f 2>&1 > /dev/null
fi

%files
%defattr(-,root,root,-)
%doc docs COPYING etc/silo.conf
/sbin/silo
%{_bindir}/tilo
%{_bindir}/maketilo
/boot/first.b
/boot/ultra.b
# /boot/cd.b
/boot/fd.b
/boot/generic.b
/boot/ieee32.b
/boot/isofs.b
/boot/silotftp.b
/boot/second.b
%{_sbindir}/silocheck
%{_mandir}/man1/tilo.1*
%{_mandir}/man1/maketilo.1*
%{_mandir}/man5/silo.conf.5*
%{_mandir}/man8/silo.8*
 
%changelog
* Wed Mar 25 2015 Philip Copeland <philip.copeland@oracle.com> 1.4.14-4.0.18
- During the package install silo is unpacked but no config file
  exists leading to a error in the install log which is *cosmetic*
  Mild alteration to check for the default config file

* Wed Mar 11 2015 Philip Copeland <philip.copeland@oracle.com> 1.4.14-4.0.17
- force silo to rebuild the sector lists for itself after an update
  without this, the .b files where occasionally moving rather than
  being overwritten in place leading to failed boots (SIProgram..)

* Thu Feb 19 2015 Philip Copeland <philip.copeland@oracle.com> 1.4.14-4.0.16
- We can use GPT now but we need to stop silo complaining about
  label magics.
- Use git in the specfile if needed

* Wed Aug 27 2014 Stanislav Kholmanskikh <stanislav.kholmanskikh@oracle.com> 1.4.14-4.0.15
- Prevent merging of labels in silo boot prompt [orabug 18533858]

* Fri Aug 30 2013 Nikita Gerasimov <nikita.gerasimov@oracle.com> 1.4.14-4.0.14
- silo.conf timeout property does not work due to overflow. Basically
  the CPU is so fast now that it overslows the signed 32bit value.
  I guess at some point it'll be even faster and we'll have to promte
  prom_getintdefault() to returning an unsigned double int.

* Fri May 24 2013 Jose E. Marchesi <jose.marchesi@oracle.com> 1.4.14-4.0.13
- The entries in the partitions array in the sun disklabel are 64 bit wide.
- Pack the ufs superblock struct.
- Pack the romfs superblock struct.
- rename RELEASE to SILO_RELEASE due to conflict with scsi/scsi.h

* Thu May 23 2013 Jose E. Marchesi <jose.marchesi@oracle.com> 1.4.14-4.0.12
- Avoid internal padding of the sun_disklabel structure in silo.c.
- Resolves Oracle #15584.

* Wed May 22 2013 Jose E. Marchesi <jose.marchesi@oracle.com> 1.4.14-4.0.11
- Kernel size expansion patch removed.
- Avoid the OBP handlers for the window over/underflow traps to assume
  a 32 bits stack.
- Resolves Oracle #15562.

* Sat May 18 2013 Philip Copeland <philip.copeland@oracle.com> 1.4.14-4.0.10
- Minor cleanup of the debug patch, just so that when compiling
  you can determine that it will use the code in the debugging section
  via a #warning directive
- remade the tarball and silo-1.4.14-__sprintf_chk.patch to
  get rid of extraneous .orig files

* Fri May 17 2013 Philip Copeland <philip.copeland@oracle.com> 1.4.14-4.0.9
- kernel size expansion from 64Mb to 128Mb
- Add DEBUG / DEBUGGING
  set DEBUG=1 in the spefile to set DEBUGGING=1 in the code
  (see Rules.make)

* Thu May 16 2013  Philip Copeland <philip.copeland@oracle.com> 1.4.14-4.0.7
- Drop "BuildArch: noarch" since we no longer build silo as a
  static 32bit binary that would otherwise confuse anaconda/rpm
- Make silo spit out a more telling version name than just 1.4.14
  add the release numbering as well

* Mon May 13 2013  Jose E. Marchesi <jose.marchesi@oracle.com> 1.4.14-4.0.5
- Build silo as a 64bit bootloader since we do not carry any 32bit
  libs (yet) this will remove the fc12 static build of silo that
  currently happens
- Based on preliminary work by Philip Copeland (Bryce).
- Fix maketilo so it can handle images bigger than 4MB.
- Resolves Oracle #14142

* Tue Mar 19 2013  philip.copeland <philip.copeland@oracle.com> 1.4.14-4.0.4
- An old chestnut. The ISO would always boot and spew out
  "EXT2 superblock magic is wrong"
  What we've done here is just reorder the silo_fs_ops structure
  so that isofs is first, since it won't generate an warning message
  like ext2 does.

* Thu Mar  7 2013  philip.copeland <philip.copeland@oracle.com> 1.4.14-4.0.3
- Added patch from Fujitsu to allow booting on Athena systems
    (1) T's OBP provides 4MB aligned memory for larger size memory.
      But Athena's OBP doesn't guarantee the 4MB alignment. 

      From the viewpoint of OBP-kernel I/F, such alignment is not defined,
      but current T's OBP always provides 4MB aligned memory to OS. 

    (2) SILO allocates memory for kernel text/data from OBP's free memory, and
      Linux kernel believes it's 4MB aligned and remaps the kernel text as 4MB alignment.
  As a result, MMU Miss trap occurs in the early phase of kernel. 

* Wed Dec  5 2012 philip.copeland <philip.copeland@oracle.com> 1.4.14-4.0.2
- Rebase to latest silo loader. Prep groundwork for additional arch changes
- This version compile statically in a Fc12 environment but something wipes
  out various defaults so we end up with a
    malloc.c:(.text+0xf8): undefined reference to `.umul'
  error, which can be 'fixed' by statically linking against -lc
  This is only a problem for statically building. If/when silo
  can be built under 64bit natively then this will vanish

* Fri Aug 17 2012 philip.copeland <philip.copeland@oracle.com> 1.4.14-4.0.1
- The append directive buffer is too small
  David sems to have arbitarily capped it at 200 chars
  I've increased it to 2047 (one less than what the 64 bit kernel will take)

* Mon Jul  2 2012 philip.copeland <philip.copeland@oracle.com> 1.4.14-4.git20100224
- Make into a noarch package and build as a static binara (very
  evil, don't do this!)
 
* Sun Jul  1 2012 philip.copeland <philip.copeland@oracle.com> 1.4.14-3.git20100224
- allow build of sparc64

* Wed Feb 24 2010 Dennis Gilmore <dennis@ausil.us> - 1.4.14-2.git20100224
- update to git snapshot

* Fri Aug 14 2009 Tom "spot" Callaway <tcallawa@redhat.com> 1.4.14-1
- update to 1.4.14
- pick up kernelheaders and gcc43 patches from gentoo
- fix issue with __sprintf_chk in e2fsprogs
- add patch from Peter to prevent overlap issues btw kernel and initrd

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.4.13-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.4.13-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Sat Mar 22 2008 Tom "spot" Callaway <tcallawa@redhat.com> 1.4.13-8
- fix for no linux/elf.h
- embed local copy of ufs_fs.h

* Fri Mar 21 2008 Tom "spot" Callaway <tcallawa@redhat.com> 1.4.13-7
- big kernel patch from davem

* Fri Sep 28 2007 Dennis Gilmore <dennis@ausil.us> 1.4.13-6
- fix defattr

* Fri Aug 24 2007 Dennis Gilmore <dennis@ausil.us> 1.4.13-5
- use %%{?_smp_mflags}

* Thu Aug 16 2007 Dennis Gilmore <dennis@ausil.us> 1.4.13-4
- use macros in %%files section

* Wed Aug 15 2007 Dennis Gilmore <dennis@ausil.us> 1.4.13-3
- add disttag, fix buildroot

* Mon May 14 2007 Tom "spot" Callaway <tcallawa@redhat.com> 1.4.13-2
- fix RAID1 case

* Mon Dec 18 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.4.13-1
- bump to 1.4.13
- use Jurij Smakov's patch for silo with modern kernel headers

* Tue May 23 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.4.11-3
- properly fix timing issue

* Tue Apr 11 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.4.11-2
- revert timer.c change

* Fri Mar 31 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.4.11-1
- bump to 1.4.11

* Wed Apr 20 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.4.9-1
- bump to 1.4.9

* Wed Jan 26 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.4.8-2
- Rebuilt

* Sat Aug 28 2004 Tom "spot" Callaway <tcallawa@redhat.com> 1.4.8-1
- bump to 1.4.8

* Thu May 20 2004 Tom "spot" Callaway <tcallawa@redhat.com> 1.4.5-2
- Back out unneeded patches

* Wed May 19 2004 Tom "spot" Callaway <tcallawa@redhat.com> 1.4.5-1
- Maybe silo works right now! Maybe I'm a giant lemur!

* Fri Apr  2 2004 Tom "spot" Callaway <tcallawa@redhat.com> 1.4.4-1
- Bump to current
- Remove old patches
- Fix duplicate sysfs definition

* Mon Dec 30 2002 Peter Jones <pjones@redhat.com> 1.2.4-11
- make dirty journals patch work
* Wed Dec 11 2002 Peter Jones <pjones@redhat.com>
- revert bigmem hack

* Thu Oct 10 2002 Tom "spot" Callaway <tcallawa@redhat.com>
- more ram than god hack

* Thu Sep 05 2002 Tom "spot" Callaway <tcallawa@redhat.com>
- bigmem hack

* Sun Aug 25 2002 Tom "spot" Callaway <tcallawa@redhat.com>
- cheetah+ patch from DaveM

* Sun Jan 27 2002 Tom "spot" Callaway <tcallawa@redhat.com>
- Peter's fixes: Fix sun4u, fix unclean ext3, add a little more debugging 
  info wrt unclean ext2 fs.
- Add post install noise about the need to rerun silo.

* Mon May 28 2001 Pieter Krul <pkrul@auxio.org>
- Updated manpath and added tilo

* Tue May 22 2001 Ben Collins <bcollins@debian.org>
- Updated for new build

* Fri Jul 14 2000 Jakub Jelinek <jakub@redhat.com>
- Pete Zaitcev's JavaStation flash patch
- work around 2.4 kernel headers

* Tue Mar  7 2000 Jakub Jelinek <jakub@redhat.com>
- Set partat0 correctly

* Tue Feb 15 2000 Jakub Jelinek <jakub@redhat.com>
- RAID1 fixes
- package ieee32 bootblock

* Mon Feb 14 2000 Jakub Jelinek <jakub@redhat.com>
- fix -J operation (hopefully)

* Fri Feb  4 2000 Jakub Jelinek <jakub@redhat.com>
- RAID1 support
- man pages are compressed

* Thu Nov 11 1999 Jakub Jelinek <jakub@redhat.com>
- fix reading above 4GB

* Wed Nov  3 1999 Jakub Jelinek <jakub@redhat.com>
- for new kernels, put initial ramdisk right after
  their _end if it fits, should fix many problems with
  initrd loading.
- removed bootfile patch - it was not working anyway
  and AFAIK noone used it

* Tue Oct 12 1999 Jakub Jelinek <jakub@redhat.com>
- fixed a horrible bug introduced in the last release.
  Thanks DaveM.

* Mon Oct 11 1999 Jakub Jelinek <jakub@redhat.com>
- fix support for less buggy PROMs (those which are able
  to read above 1GB, but not 2GB).

* Fri Oct  8 1999 Jakub Jelinek <jakub@redhat.com>
- use some partition device and not whole device if
  possible for masterboot installs
- remove a lot of old cruft, including -d, -o and -O
  options
- no longer do any heuristic about where to put
  the bootblock, simply if -t is not given, it goes
  to bootblock at cylinder 0, otherwise to the
  partition bootblock
- make silotftp.b work

* Wed Oct  6 1999 Jakub Jelinek <jakub@redhat.com>
- brown paper bag bugfix to get cd booting of
  gzipped images working

* Mon Oct  4 1999 Jakub Jelinek <jakub@redhat.com>
- fix bug on traversing non-absolute symlinks

* Tue Sep 28 1999 Jakub Jelinek <jakub@redhat.com>
- don't install silo in %%post.

* Thu Sep 23 1999 Jakub Jelinek <jakub@redhat.com>
- actually install the new man page.

* Mon Sep 20 1999 Jakub Jelinek <jakub@redhat.com>
- update to 0.8.8.

* Fri Sep 17 1999 Jakub Jelinek <jakub@redhat.com>
- update to 0.8.7.

* Tue Apr 20 1999 Jakub Jelinek <jj@ultra.linux.cz>
- update to 0.8.6.

* Tue Apr 13 1999 Jeff Johnson <jbj@redhat.com>
- update to pre0.8.6-1.

* Mon Mar 22 1999 Bill Nottingham <notting@redhat.com>
- fix password checking (bug #1054)

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 4)

* Fri Mar 12 1999 Jeff Johnson <jbj@redhat.com>
- add -lc to work around mis-built libext2fs.so

* Thu Dec 17 1998 Jeff Johnson <jbj@redhat.com>
- update to 0.8.5.

* Thu Nov  5 1998 Jeff Johnson <jbj@redhat.com>
- update to 0.8.2.

* Mon Oct 19 1998 Jeff Johnson <jbj@redhat.com>
- update to 0.8.1.

* Wed Sep 30 1998 Jeff Johnson <jbj@redhat.com>
- update to 0.8.
- run silo automagically on install.

* Wed Sep 23 1998 Jeff Johnson <jbj@redhat.com>
- update to pre-0.7.3-3.

* Tue Aug  4 1998 Jeff Johnson <jbj@redhat.com>
- build root
